<?php
declare(strict_types=1);

namespace Flat101\EnhancedEcommerce\Model\DataLayerGa4\Impressions;

use Flat101\EnhancedEcommerce\Api\Data\DataLayerInterface;
use Flat101\EnhancedEcommerce\Model\Session;
use Magento\Framework\Event\Manager;

class AddToCartImpressionView implements DataLayerInterface
{
    public const CODE = 'addtocart-impression-view-ga4';

    /**
     * @var Session
     */
    private $session;

    /**
     * @var Manager
     */
    private $eventManager;

    public function __construct(Session $session, Manager $eventManager)
    {
        $this->session = $session;
        $this->eventManager = $eventManager;
    }

    public function getCode(): string
    {
        return static::CODE;
    }

    /**
     * {@inheritdoc}
     */
    public function getLayer(): ?array
    {
        $ecommerceClick = $this->session->getAddProductToCart(false,true);

        $impression = 0 < count($ecommerceClick) ? $ecommerceClick : null;

        $this->eventManager->dispatch('flat101_enhancedecommerce_click_impression_view_ga4', [
            'dataLayer' => $impression,
        ]);

        return $impression;
    }
}
