<?php
declare(strict_types=1);

namespace Flat101\EnhancedEcommerce\Plugin\Newsletter;

use Magento\Framework\App\Request\Http;
use Flat101\EnhancedEcommerce\Model\DataLayer\Generator\BehavioralEvent;
use Flat101\EnhancedEcommerce\Model\Session;
use Magento\Newsletter\Model\SubscriptionManager AS DefaultSubscriptionManager;

class SubscriberManagement
{
    private const EVENT = 'Newsletter';
    private const EVENT_ACTION = 'Newsletter';
    private const EVENT_LABEL = 'Registro';

    /** @var Http */
    protected $request;

    /** @var BehavioralEvent */
    protected $behavioralEvent;

    /** @var Session */
    protected $customSession;

    /**
     * NewsletterSubscriber constructor.
     * @param Http $request
     * @param BehavioralEvent $behavioralEvent
     * @param Session $customSession
     */
    public function __construct(
        Http $request,
        BehavioralEvent $behavioralEvent,
        Session $customSession
    ) {
        $this->request = $request;
        $this->behavioralEvent = $behavioralEvent;
        $this->customSession = $customSession;
    }

    /**
     * @param DefaultSubscriptionManager $subject
     * @param $result
     * @return mixed
     */
    public function afterSubscribeCustomer(DefaultSubscriptionManager $subject, $result)
    {
        if ($result->isSubscribed()) {
            $locate = $this->request->getPost('locate');

            $this->customSession->setBehavioralEvent(
                $this->behavioralEvent->generate(self::EVENT, $locate, self::EVENT_ACTION, self::EVENT_LABEL)
            );
        }

        return $result;
    }
}
